%{

/*
   strip.l -- PIKT piktc preprocessor for stripping away all comments
              from master config files

   $Header: /var/cvs/PIKT/pikt/src/piktc/strip.l,v 1.14 2006/11/04 09:59:36 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-2006 by Robert Osterlund.

   PIKT is a trademark of the University of Chicago.  All Rights Reserved.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   Send problem reports, bouquets and brickbats to:  pikt-bugs@pikt.org
 */

#include "../lib/common.h"
#include "piktc.h"

%}

W	[ \t]

%x FIXED CMNT0 CMNT1

%option noyywrap

%%

<INITIAL>("\\/*"|"/\\*"|"\\/\\*") { fprintf(stripout, "/*"); }
<INITIAL>("\\*/"|"*\\/"|"\\*\\/") { fprintf(stripout, "*/"); }
<INITIAL>("\\//"|"/\\/"|"\\/\\/") { fprintf(stripout, "//"); }

<CMNT0,CMNT1>("\\/*"|"/\\*"|"\\/\\*") { ; }
<CMNT0,CMNT1>("\\*/"|"*\\/"|"\\*\\/") { ; }
<CMNT0,CMNT1>("\\//"|"/\\/"|"\\/\\/") { ; }

<INITIAL>^#{W}*(fix|freeze){W}*\n { BEGIN(FIXED);
				  ECHO;
				}
<INITIAL>"/*"			{ BEGIN(CMNT0); }
<INITIAL>{W}*"//"		{ BEGIN(CMNT1); }
<INITIAL,FIXED>\n		{ ECHO; }
<INITIAL,FIXED>.		{ ECHO; }

<FIXED>^#{W}*(unfix|unfreeze){W}*\n { BEGIN(INITIAL);
				  ECHO;
				}

<FIXED>^#{W}*(fix|freeze){W}*	{ fprintf(stripout, "ERR%s", yytext); }
<INITIAL>^#{W}*(unfix|unfreeze){W}* { fprintf(stripout, "ERR%s", yytext); }

<CMNT0>"*/"			{ BEGIN(INITIAL); }
<CMNT0>"*/"{W}*\n		{ BEGIN(INITIAL);
				  fputc('\177', stripout);
				  fputc('\n', stripout);
				}
<CMNT0>\n			{ fputc('\177', stripout);
				  fputc('\n', stripout);
				}
<CMNT0>.			{ ; }

<CMNT1>.+			{ ; }
<CMNT1>\n			{ BEGIN(INITIAL);
				  fputc('\177', stripout);
				  fputc('\n', stripout);
				}

%%
